package net.shrine.adapter.dao.squeryl.tables

import org.squeryl.{Schema, Table}
import net.shrine.adapter.dao.model.squeryl.{SquerylQueryResultRow, SquerylShrineQuery}
import net.shrine.dao.squeryl.tables.AbstractTableComponent
import net.shrine.dao.squeryl.SquerylEntryPoint

/**
 * @author clint
 * @since May 22, 2013
 */
trait ShrineQueriesComponent extends AbstractTableComponent { self: Schema with QueryResultsComponent =>

  import SquerylEntryPoint._

  val shrineQueries: Table[SquerylShrineQuery] = table[SquerylShrineQuery]("SHRINE_QUERY")

  val queriesToResults: SquerylEntryPoint.OneToManyRelationImpl[SquerylShrineQuery, SquerylQueryResultRow] = {
    val relation = oneToManyRelation(shrineQueries, queryResults).via {
      (query, result) => query.id === result.queryId
    }
    
    relation.foreignKeyDeclaration.constrainReference(onDelete.cascade)
    
    relation
  }
  
  declareThat(shrineQueries)(
    _.id is (primaryKey, oracleSafeAutoIncremented("SHRINE_QUERY_ID"))
  )
}