package net.shrine

/**
  * Created by marc-danie on 3/23/18.
  */

import cats.effect.{ConcurrentEffect, ContextShift, IO}
import javax.servlet.{ServletContextEvent, ServletContextListener}
import javax.servlet.annotation.WebListener
import net.shrine.http4s.servlet.syntax.ShrineServletContextSyntax

import scala.concurrent.ExecutionContext.global
import scala.concurrent.duration.DurationInt

@WebListener
class Bootstrap extends ServletContextListener {

  override def contextInitialized(sce: ServletContextEvent): Unit = {
    val context = sce.getServletContext

    //TODO: find out why AutoSlash middleware does not work - SHRINE-2581

    implicit val contextShift: ContextShift[IO] = IO.contextShift(global)
    implicit val concurrentEffect: ConcurrentEffect[IO] = IO.ioConcurrentEffect(contextShift)

    ShrineServletContextSyntax.mountService(
      context = context,
      name = "SHRINE Server Sent Event Example",
      service = Http4sServerSentEventApp.service,
      mapping = "/sse/*"
    )

    ShrineServletContextSyntax.mountService(
      context = context,
      name = "SHRINE Server Sent Event with Authentication Example",
      service = Http4sServerSentEventApp.authRouter,
      mapping = "/authSSE/*"
    )
  }
}