package net.shrine.authorization

import net.shrine.problem.{AbstractProblem, ProblemSources}

/**
 * @author Bill Simons
 * @date Aug 24, 2010
 * @link http://cbmi.med.harvard.edu
 * @link http://chip.org
 * <p/>
 * NOTICE: This software comes with NO guarantees whatsoever and is
 * licensed as Lgpl Open Source
 * @link http://www.gnu.org/licenses/lgpl.html
 */
final case class AuthorizationException(domain: String, username: String,reason: String) extends RuntimeException(s"Can not authorize $username:$domain $reason") {

  def problem = NotAuthorizedProblem(this)
}

case class NotAuthorizedProblem(ax:AuthorizationException) extends AbstractProblem(ProblemSources.Qep){
  override val summary = s"${ax.getLocalizedMessage}."

  override val throwable = Some(ax)

  override val description = s"${ax.getLocalizedMessage}"
}