package net.shrine.http4s.client.legacy

import java.net.URL
import java.util.concurrent.TimeUnit

import com.typesafe.config.Config

import scala.concurrent.duration.FiniteDuration

/**
 * @author clint
 * @since Dec 5, 2013
 */
final case class EndpointConfig(url: URL, timeout: FiniteDuration)

object EndpointConfig {
  object Keys {
    val url = "url"
    val timeout = "timeout"
  }

  val defaultTimeout = FiniteDuration.apply(4,TimeUnit.DAYS)

  def apply(config: Config): EndpointConfig = {
    val url = new URL(config.getString(Keys.url))
    val timeout = {
      import net.shrine.config.ConfigExtensions
      config.getFiniteDuration(Keys.timeout)
      if(config.hasPath(Keys.timeout)) config.getFiniteDuration(Keys.timeout)
      else defaultTimeout
    }
    
    EndpointConfig(url, timeout)
  }
}