package net.shrine.http4s.client.legacy

import net.shrine.crypto.BouncyKeyStoreCollection

/**
 * @author clint
 * @since Dec 18, 2013
 */

//todo add an apply(Config based on EndpointConfig)
final case class Poster(url: String, httpClient: HttpClient) {
  def post(data: String): HttpResponse = httpClient.post(data, url)
  
  def mapUrl(f: String => String): Poster = copy(url = f(url))
}

object Poster {
  //todo a version based on config
  //todo should the client verify the server's cert SHRINE-3661
  def apply(keystoreCertCollection: BouncyKeyStoreCollection, endpoint: EndpointConfig):Poster = {

    val httpClient = Http4sLegacyClient(endpoint.timeout)

    Poster(endpoint.url.toString, httpClient)
  }
}
