package net.shrine.http4s.catsio

import java.io.{ByteArrayOutputStream, PrintStream}

import org.junit.{AfterClass, BeforeClass}

/**
  * Redirect stdout to a print stream accessible directly by tests.
  */
trait LoggingTest {
  final val out: ByteArrayOutputStream = new ByteArrayOutputStream()
  final val originalOut: PrintStream = System.out

  @BeforeClass
  def before(): Unit = {
    System.setOut(new PrintStream(out))
  }

  @AfterClass
  def after(): Unit = {
    System.setOut(originalOut)
  }
}
