package net.shrine.http4s.client.legacy

import java.net.URL

import com.typesafe.config.ConfigFactory
import net.shrine.util.ShouldMatchersForJUnit
import org.junit.Test

import scala.concurrent.duration.DurationInt

/**
 * @author clint
 * @since Dec 5, 2013
 */
final class EndpointConfigTest extends ShouldMatchersForJUnit {
  @Test
  def testApply() {
    def url(s: String) = new URL(s)
    
    intercept[Exception] {
      EndpointConfig(ConfigFactory.empty)
    }

    {
      val configText = """
      foo {
        bar = 123
        baz = 456
        fooEndpoint {
          url = "http://example.com"
          timeout = "123 days"
        }
      }"""

      val endpoint = EndpointConfig(ConfigFactory.parseString(configText).getConfig("foo.fooEndpoint"))

      endpoint.url should equal(url("http://example.com"))
      endpoint.timeout should equal(123.days)
    }
  }
}

object EndpointConfigTest {
  def endpoint(url: String): EndpointConfig = EndpointConfig(new URL(url), 1.second)
}