package net.shrine.protocol

import net.shrine.protocol.handlers.ReadApprovedTopicsHandler
import net.shrine.protocol.handlers.ReadPreviousQueriesHandler
import net.shrine.protocol.handlers.ReadQueryDefinitionHandler
import net.shrine.protocol.handlers.ReadQueryInstancesHandler
import net.shrine.protocol.handlers.ReadQueryResultHandler
import net.shrine.protocol.handlers.RenameQueryHandler
import net.shrine.protocol.handlers.RunQueryHandler
import net.shrine.protocol.handlers.ReadTranslatedQueryDefinitionHandler
import net.shrine.protocol.handlers.FlagQueryHandler
import net.shrine.protocol.handlers.UnFlagQueryHandler

/**
 * @author Bill Simons
 * @since 3/9/11
 * @see http://cbmi.med.harvard.edu
 * @see http://chip.org
 *       <p/>
 *       NOTICE: This software comes with NO guarantees whatsoever and is
 *       licensed as Lgpl Open Source
 * @see http://www.gnu.org/licenses/lgpl.html
 */
//todo maybe delete with SHRINE-3633, maybe has to wait for consolidating AIM 3 API calls in SHRINE-3540
trait ShrineRequestHandler extends 
	ReadPreviousQueriesHandler[ReadPreviousQueriesRequest, BaseShrineResponse] with
	ReadApprovedTopicsHandler[ReadApprovedQueryTopicsRequest, BaseShrineResponse] with
	ReadQueryInstancesHandler[ReadQueryInstancesRequest, BaseShrineResponse] with 
	ReadQueryDefinitionHandler[ReadQueryDefinitionRequest, BaseShrineResponse] with
	RunQueryHandler[RunQueryRequest, BaseShrineResponse] with 
	RenameQueryHandler[RenameQueryRequest, BaseShrineResponse] with
	ReadQueryResultHandler[ReadQueryResultRequest, BaseShrineResponse] with
	ReadTranslatedQueryDefinitionHandler[ReadTranslatedQueryDefinitionRequest, BaseShrineResponse] with
	FlagQueryHandler[FlagQueryRequest, BaseShrineResponse] with
	UnFlagQueryHandler[UnFlagQueryRequest, BaseShrineResponse]
	
