package net.shrine.protocol

import net.shrine.util.ShouldMatchersForJUnit
import org.junit.Test
import net.shrine.protocol.query.QueryDefinition
import net.shrine.protocol.query.Term

/**
 * @author clint
 * @date Feb 13, 2014
 */
final class NonI2b2ShrineResponseTest extends ShouldMatchersForJUnit {
  @Test
  def testFromXml {
    import NonI2b2ShrineResponse.fromXml
    
    fromXml(DefaultBreakdownResultOutputTypes.toSet)(<foo/>).isFailure should be(true)
    
    {
      val resp = SingleNodeReadTranslatedQueryDefinitionResponse(SingleNodeTranslationResult(XmlNodeName("nuh"), QueryDefinition("foo", Term("blarg", "blargName"))))
      
      fromXml(DefaultBreakdownResultOutputTypes.toSet)(resp.toXml).get should equal(resp)
    }
    
    {
      val resp = AggregatedReadTranslatedQueryDefinitionResponse(Seq(
          SingleNodeTranslationResult(XmlNodeName("nuh"), QueryDefinition("foo", Term("blarg", "blargName"))),
          SingleNodeTranslationResult(XmlNodeName("zuh"), QueryDefinition("bar", Term("asdf", "asdfName")))
          ))
      
      fromXml(DefaultBreakdownResultOutputTypes.toSet)(resp.toXml).get should equal(resp)
    }
  }
}