package net.shrine.protocol.version

import net.shrine.protocol.version.v1.V1JsonTest
import net.shrine.util.ShouldMatchersForJUnit
import org.junit.Test

class V1EnvelopeTest extends ShouldMatchersForJUnit {

  val jsonEnvelope = V1JsonTest.readJsonFile("/envelope.json")
  val expectedEnvelope = Envelope(
    contents = "test contents",
    contentsType = "test contents type",
    contentsSubject = 0
  )

  @Test
  def testEnvelopeAgainstV1Json():Unit = {
    assertResult(jsonEnvelope){ expectedEnvelope.asJsonText.underlying }
    assertResult(expectedEnvelope){ Envelope.tryRead(new JsonText(jsonEnvelope)).get }
  }
}
