package net.shrine.protocol.version.v1

import net.shrine.protocol.version.MomQueueName
import net.shrine.util.ShouldMatchersForJUnit
import org.junit.Test

class NetworkTest extends ShouldMatchersForJUnit {

  val jsonNetwork: String = V1JsonTest.readJsonFile("/network.json")

  val expectedNetwork = Network(
    networkName = "testNetwork",
    versionInfo = V1JsonTest.staticVersionInfo,
    hubQueueName = new MomQueueName("testMomQueueName"),
    adminEmail = "test_email@email.mail"
  )

  @Test
  def testNetworkAgainstV1Json():Unit = {
    V1JsonTest.testRoundTrip(jsonNetwork, expectedNetwork, Network.tryRead)
  }
}
