package net.shrine.protocol.version.v1

import net.shrine.protocol.version.QueryId
import org.junit.Test

class UpdateQueryAtAdapterTest {

  val jsonUpdateQueryAtAdapterWithName = V1JsonTest.readJsonFile("/updateQueryAtAdapterWithName.json")
  val jsonUpdateQueryAtAdapterWithFlagging = V1JsonTest.readJsonFile("/updateQueryAtAdapterWithFlagging.json")

  val expectedUpdateQueryAtAdapterWithName = UpdateQueryAtAdapterWithName (
    queryId = new QueryId(V1JsonTest.staticQueryId),
    queryName = "test query name"
  )
  val expectedUpdateQueryAtAdapterWithFlagging = UpdateQueryAtAdapterWithFlagging (
    queryId = new QueryId(V1JsonTest.staticQueryId),
    flagged = true,
    flaggedMessage = Some("test flagged message")
  )

  @Test
  def testUpdateQueryAtAdapterAgainstV1Json():Unit = {
    V1JsonTest.testRoundTrip(jsonUpdateQueryAtAdapterWithName, expectedUpdateQueryAtAdapterWithName, UpdateQueryAtAdapter.tryRead)
    V1JsonTest.testRoundTrip(jsonUpdateQueryAtAdapterWithFlagging, expectedUpdateQueryAtAdapterWithFlagging, UpdateQueryAtAdapter.tryRead)
  }
}
