package net.shrine.protocol.version.v1

import net.shrine.problem.{JsonProblemDigest, TestProblem}
import org.junit.Test

class UpdateQueryAtQepTest {

  val jsonUpdateQueryAtQepWithStatus = V1JsonTest.readJsonFile("/updateQueryAtQepWithStatus.json")
  val jsonUpdateQueryAtQepWithError = V1JsonTest.readJsonFile("/updateQueryAtQepWithError.json")
  val jsonUpdateQueryReadyForAdapters = V1JsonTest.readJsonFile("/updateQueryReadyForAdapters.json")

  val expectedUpdateQueryAtQepWithStatus = UpdateQueryAtQepWithStatus(V1JsonTest.staticQueryProgress)
  val expectedUpdateQueryAtQepWithError = UpdateQueryAtQepWithError (
    queryId = V1JsonTest.staticQueryProgress.id,
    problemDigest = JsonProblemDigest(TestProblem()),
    changeDate = V1JsonTest.staticDateStamp
  )
  val expectedUpdateQueryReadyForAdapters = UpdateQueryReadyForAdapters (
    query = V1JsonTest.staticQueryProgress,
    resultProgresses = Seq (V1JsonTest.staticResultProgress)
  )

  @Test
  def testUpdateQueryAtQepAgainstV1Json():Unit = {
    V1JsonTest.testRoundTrip(jsonUpdateQueryAtQepWithStatus, expectedUpdateQueryAtQepWithStatus, UpdateQueryAtQep.tryRead)
    V1JsonTest.testRoundTrip(jsonUpdateQueryAtQepWithError, expectedUpdateQueryAtQepWithError, UpdateQueryAtQep.tryRead)
    V1JsonTest.testRoundTrip(jsonUpdateQueryReadyForAdapters, expectedUpdateQueryReadyForAdapters, UpdateQueryAtQep.tryRead)
  }
}
