package net.shrine.config

import net.shrine.source.ConfigSource
import org.junit.{Ignore, Test}
import org.scalatestplus.junit.AssertionsForJUnit

final class ConfigSourceTest extends AssertionsForJUnit {

  @Test
  def testFromReference(): Unit = {
    assertResult("from reference.conf")(ConfigSource.config.getString("referenceTestTarget"))
  }

  @Test
  def testFromShrine() {
    ConfigSource.config

    assertResult("from shrine.conf")(ConfigSource.config.getString("shrineTestTarget"))
  }

  @Test
  def testFromQa() {
    assertResult("from override.conf")(ConfigSource.config.getString("qaTestTarget"))
  }

  @Test
  def testOverrideReference(): Unit = {
    assertResult("from shrine.conf")(ConfigSource.config.getString("overrideReferenceTestTarget"))
  }

  @Test
  def testOverrideNetworkConf() {
    assertResult("from shrine.conf")(ConfigSource.config.getString("overrideNetworkTestTarget"))
  }

  @Test
  @Ignore //this can't be done because slick's GlobalConfig calls ConfigFactory.load()
  def testSupplyVariableToReferenceConf() {
    assertResult("from shrine.conf")(ConfigSource.config.getString("requiredByReferenceConfTestTarget"))
  }

  @Test
  @Ignore //this can't be done because slick's GlobalConfig calls ConfigFactory.load()
  def testOverrideReferenceVariableUsedInShrineConf() {
    assertResult("from override.conf")(ConfigSource.config.getString("overrideVariablesTestTarget"))
  }

  @Test
  def testOverrideVariableUsedInShrineConf() {
    assertResult("from override.conf")(ConfigSource.config.getString("overrideShrineVariablesTestTarget"))
  }

  @Test
  def testNullAShrineValueInShrineConf() {
    assertResult(false)(ConfigSource.config.hasPath("nullAShrineValue"))
  }

}