package net.shrine.util

import org.junit.Test
import org.junit.Assert.assertEquals
import scala.util.Random.shuffle

class SortTest extends ShouldMatchersForJUnit {
  val stackOverflowExamplesSorted = List(
    "2",
    "12",
    "200000",
    "1000000",
    "a",
    "a12",
    "b2",
    "text2",
    "text2a",
    "text2a2",
    "text2a12",
    "text2b",
    "text12",
    "text12a"
  )

  // A truly alphanumeric example
  val qepAgeResultsSorted = List(
    "0-9 years old",
    "10-17 years old",
    "18-34 years old",
    "35-44 years old",
    "45-54 years old",
    "55-64 years old",
    "65-74 years old",
    "75-84 years old",
    ">= 65 years old",
    ">= 85 years old",
  )

  // Just alphabetic
  val qepRaceResultsSorted = List(
    "Aleutian",
    "American Indian",
    "Asian",
    "Asian Pacific Islander",
    "Black",
    "Eskimo",
    "Hispanic",
    "Indian",
    "Middle Eastern",
    "Multiracial",
    "Native American",
    "Navajo",
    "Not recorded",
    "Oriental",
    "Other",
    "White",
  )

  // Caps before lowecase
  val mixedCaseSorted = List(
    "A",
    "AA",
    "Aa",
    "B",
    "Zebra",
    "z",
    "z1",
    "za"
  )

  val allExamplesSorted = List(stackOverflowExamplesSorted, qepAgeResultsSorted, qepRaceResultsSorted, mixedCaseSorted)

  @Test
  def testAlphaNumericSort: Unit = {
    for (example <- allExamplesSorted) {
      assertEquals(example, Sort.sortAlphaNumerically(shuffle(example)))
    }
  }
}
