
/**
 * This class wraps the globally namespaced variables in a class and allows the use of the $ reference for projects 
 * that use both JQuery and Prototype.js. It also provides convenience methods for referencing the globally scoped i2b2 variable.
 */

import jQuery from 'jquery';

class ContextWrapper {
  setContext(rootContext) {
    this.global = rootContext;
    this.jQuery = jQuery;
    return this;
  }

  get i2b2() {
    return this.global.i2b2;
  }

  get shrine() {
    return this.i2b2.SHRINE;
  }

  get $() {
    return this.jQuery;
  }

  get prototype$() {
    return this.global.$;
  }

  get prototype$$() {
    return this.global.$$;
  }

  get YAHOO() {
    return this.global.YAHOO;
  }
}
export default ContextWrapper;
