import { DEFAULT_MESSAGE, WIKI_BASE_URL } from '../common/constants';
import { EmailInstructions } from './EmailInstructions';
import { lineFormatConverter } from '../common/lineFormatConverter';

export const ProblemDigestContent = ({ data, emailTo = null }) => {
  const codec = data.problemDigest.codec || '';
  const subject = data.status || DEFAULT_MESSAGE;
  const emailInstructions = EmailInstructions({ emailTo, subject });

  return `
        <div class="StatusBoxText problemDigestContent">
        <p class="instructions">
          ${emailInstructions}
        </p>
        <hr/> 
        <div>
          <b>Summary:</b>
        </div> 
        <div>  
          ${(data.problemDigest && data.problemDigest.summary) || DEFAULT_MESSAGE}
        </div>
        <br/> 
        <div>
          <b>Description:</b>
        </div> 
        <div>
          <p>  ${(data.problemDigest && data.problemDigest.description) || DEFAULT_MESSAGE}  </p>
        </div>
        <br/> 
        <span id="pluginMoreDetail"> 
          <div>
            <b>Codec:</b>
          </div> 
          <div>  
            ${data.problemDigest.codec ? data.problemDigest.codec : DEFAULT_MESSAGE}
          </div> 
          <div>
            <i>For information on troubleshooting and resolution, check <a href="${WIKI_BASE_URL}${codec}" target="_blank">the SHRINE Error Codex</a>.</i>
          </div>
          <br/> 
          <div>
            <b>Stamp:</b>
          </div> 
          <div>  
            ${data.problemDigest.stampText ? data.problemDigest.stampText : DEFAULT_MESSAGE}  
          </div>
          <br/> 
          <div>
            <b>Name:</b>
          </div> 
          <div>  
            ${data.problemDigest.codec ? data.problemDigest.codec : DEFAULT_MESSAGE}  
          </div>
          <br/> 
          <div>
            <b>Message:</b>
          </div> 
          <div>  
            ${data.problemDigest.description ? data.problemDigest.description : DEFAULT_MESSAGE}  
          </div>
          <br/> 
          <div>
            <b>Details:</b>
          </div> 
          <div>  
            ${lineFormatConverter(data)}  
          </div>
          <br/> 
        </span>
          </div> 
    `;
};
