import { EmailInstructions } from '../EmailInstructions';

describe('EmailInstructions', () => {
  it('Should render Email instructions if email is provided', () => {
    const data = {
      emailTo: 'mock@mock.email',
      subject: 'mock email subject',
      body: 'mock email body',
    };
    const expected = `
    If you would like to report this error, please copy the entire message below and paste<br/>      into an       <a href=\"mailto:mock@mock.email?subject=mock%20email%20subject\">        email      </a>     to your local site administrator.
    `;
    const actual = EmailInstructions({ ...data });
    expect(actual.split('\n').join('').trim()).toEqual(expected.split('\n').join('').trim());
  });
});