import { ErrorDialogue } from '../ErrorDialogue';

describe('ErrorDialog', () => {
  const data = {
    status: 'mock status',
    statusMessage: 'Mock status message',
    problemDigest: {
      codec: 'mock codec',
      stampText: 'mock stamp text',
      description: 'mock description',
      summary: 'mock summary',
      detailsText: '<line><details>Mock details here</details></line><line><details>Mock details here</details></line>',
    },
  };

  it('Should render an error dialog', () => {
    const emailTo = 'mock@mock.email';
    const expected = `<div id=\"pluginErrorDetail\" class=\"ErrorDialogue\">
    <div class=\"hd\">
      Query Error Detail
    </div>
    <div class=\"bd\">
      <br />

      <div class=\"StatusBoxText problemDigestContent\">
      <p class=\"instructions\">

      If you would like to report this error, please copy the entire message below and paste<br/>      into an       <a href=\"mailto:mock@mock.email?subject=mock%20status\">        email      </a>     to your local site administrator.

      </p>
      <hr/>
      <div>
        <b>Summary:</b>
      </div>
      <div>
        mock summary
      </div>
      <br/>
      <div>
        <b>Description:</b>
      </div>
      <div>
        <p>  mock description  </p>
      </div>
      <br/>
      <span id=\"pluginMoreDetail\">
        <div>
          <b>Codec:</b>
        </div>
        <div>
          mock codec
        </div>
        <div>
          <i>For information on troubleshooting and resolution, check <a href=\"https://open.med.harvard.edu/wiki/display/SHRINE/mock codec\" target=\"_blank\">the SHRINE Error Codex</a>.</i>
        </div>
        <br/>
        <div>
          <b>Stamp:</b>
        </div>
        <div>
          mock stamp text
        </div>
        <br/>
        <div>
          <b>Name:</b>
        </div>
        <div>
          mock codec
        </div>
        <br/>
        <div>
          <b>Message:</b>
        </div>
        <div>
          mock description
        </div>
        <br/>
        <div>
          <b>Details:</b>
        </div>
        <div>
          <br/>Mock details here<br/>Mock details here
        </div>
        <br/>
      </span>
        </div>

  </div>
</div>
    `;
    const actual = ErrorDialogue({ data, emailTo });
    expect(actual.replace(/ /g, '').split('\n').join('')).toEqual(expected.replace(/ /g, '').split('\n').join(''));
  });
});
