import { ProblemDigest, ProblemDigestContent } from '../ProblemDigestContent';

describe('ProblemDigestContent', () => {

  const data = {
    status: 'mock status',
    statusMessage: 'Mock status message',
    problemDigest: {
      codec: 'mock codec',
      stampText: 'mock stamp text',
      summary: 'mock summary',
      description: 'mock description',
      detailsText: '<line><details>Mock details here</details></line><line><details>Mock details here</details></line>',
    },
  };

  it('Should render ProblemDigestContent', () => {
    const expected = `
    <div class="StatusBoxText problemDigestContent">
    <p class="instructions">

    If you would like to report this error, please copy the entire message below and paste<br/>
    into an
    <ahref=\"mailto:mock@mock.email?subject=mock%20status\">
    email
    </a>
    to your local site administrator.

    </p>
    <hr/>
    <div>
      <b>Summary:</b>
    </div>
    <div>
      mock summary
    </div>
    <br/>
    <div>
      <b>Description:</b>
    </div>
    <div>
      <p>  mock description  </p>
    </div>
    <br/>
    <span id="pluginMoreDetail">
      <div>
        <b>Codec:</b>
      </div>
      <div>
        mock codec
      </div>
      <div>
        <i>For information on troubleshooting and resolution, check <a href="https://open.med.harvard.edu/wiki/display/SHRINE/mock codec" target="_blank">the SHRINE Error Codex</a>.</i>
      </div>
      <br/>
      <div>
        <b>Stamp:</b>
      </div>
      <div>
        mock stamp text
      </div>
      <br/>
      <div>
        <b>Name:</b>
      </div>
      <div>
        mock codec
      </div>
      <br/>
      <div>
        <b>Message:</b>
      </div>
      <div>
        mock description
      </div>
      <br/>
      <div>
        <b>Details:</b>
      </div>
      <div>
        <br/>Mock details here<br/>Mock details here
      </div>
      <br/>
    </span>
      </div>
    `;
    const actual = ProblemDigestContent({ data, emailTo: 'mock@mock.email' });
    expect(actual.replace(/ /g, '')).toEqual(expected.replace(/ /g, ''));
  });
});
