import { queryNetworkIdReceived } from 'sandbox/actions/queryNetworkIdReceived';

const getChildRecordsDecorator = (context) => {
  const { store } = context;
  return (sdxParentNode, onCompleteCallback) => {
    const networkId = sdxParentNode.origData.id
    const name = sdxParentNode.origData.realname;
    context.i2b2.CRC.ctrlr.currentQueryStatus = false;
    context.i2b2.events.clearQuery.fire();
    store.dispatch(queryNetworkIdReceived({ networkId, name }));
    context.i2b2.CRC.ctrlr.QT.doQueryLoad(networkId);
    context.i2b2.CRC.view.history.yuiTree.locked = false;
    context.i2b2.CRC.view.history.yuiTree._nodes.map(n => n.isLoading = false);
    context.$('.sdxDefaultQM').css('background-color', 'white');
    context.$(`#${sdxParentNode.renderData.htmlID} .sdxDefaultQM`).css('background-color', '#c0e0e0');
  }
}
export default getChildRecordsDecorator;