import './retrofitter.scss';
import messenger from './shrine.messenger';
import controller from './shrine.controller';
import shrinePlugin from './shrinePlugin';
import bootstrapper from './shrineBootstrapper';

const GLOBAL = window || { };
export const setContext = (context = GLOBAL, store = { /* TODO */}) => {
  messenger.init(context);
  controller.init(context);
  return new Promise(async (resolve) => {
    await shrinePlugin.init(context, store);
    bootstrapper.bootstrapTo(context, store);
    resolve(context);
  });
};
