import {
  fetchQueryResults,
  fetchQueryResultsPending,
  fetchQueryResultsFulfilled,
  fetchQueryResultsRejected
}
  from 'sandbox/actions';

describe('Fetch Query Results', () => {
  it('Should have a well formatted fetchQueryResults action', () => {
    const expected = {
      type: 'FETCH_QUERY_RESULTS',
      payload: 'mock payload',
    };
    const actual = fetchQueryResults('mock payload');
    expect(actual).toEqual(expected);
  });

  it('Should have a well formatted fetchQueryResultsPending action', () => {
    const expected = {
      type: 'FETCH_QUERY_RESULTS_PENDING',
    };
    const actual = fetchQueryResultsPending();
    expect(actual).toEqual(expected);
  });

  it('Should have a well formatted fetchQueryResultsFulfilled action', () => {
    const expected = {
      type: 'FETCH_QUERY_RESULTS_FULFILLED',
      payload: 'mock payload',
    };
    const actual = fetchQueryResultsFulfilled('mock payload');
    expect(actual).toEqual(expected);
  });

  it('Should have a well formatted fetchQueryResultsRejected action', () => {
    const expected = {
      type: 'FETCH_QUERY_RESULTS_REJECTED',
      errorData: 'mock error data',
    };
    const actual = fetchQueryResultsRejected('mock error data');
    expect(actual).toEqual(expected);
  });
});