import React from 'react';
import PropTypes from 'prop-types';
import { BreakdownType } from 'sandbox/types';
import { GraphSet } from 'sandbox/components/Graphing';

export const BreakdownList = ({ breakdowns }) => (
  <div>
    {breakdowns.map(breakdown => (
      <GraphSet
        title={breakdown.institution}
        dataSet={breakdown.results}
      />
    ))}
  </div>
);

BreakdownList.propTypes = {
  breakdowns: PropTypes.arrayOf(BreakdownType).isRequired,
};
