import React from 'react';
import PropTypes from 'prop-types';
import { mapBreakdownsToArray } from 'sandbox/services';
import { BreakdownType } from 'sandbox/types';
import { BreakdownList } from './BreakdownList';
import './Breakdowns.scss';

export const Breakdowns = ({ children, breakdowns, breakdownMsg }) => {
  const results = mapBreakdownsToArray(breakdowns);
  return (
    <div className="Breakdowns">
      {results.length > 0
        ? <BreakdownList breakdowns={results} title={children} />
        : <div className="msg">{breakdownMsg}</div>
      }
    </div>
  );
};

Breakdowns.propTypes = {
  children: PropTypes.string.isRequired,
  breakdowns: PropTypes.arrayOf(BreakdownType).isRequired,
  breakdownMsg: PropTypes.string.isRequired,
};
