import React from 'react';
import PropTypes from 'prop-types';
import { count as countConverter } from 'sandbox/converters';

export const Bar = ({ value, width, label }) => (
  <div className="Bar">
    <div className="column left">
      <div className="pad-left">
        {label}
      </div>
    </div>
    <div className="column right">
      <div className="graphic" style={{ width: `${width}%` }}>
        {width >= 50 &&
          <div className="inner-label">
            {countConverter(value)}
          </div>
        }
      </div>
      {width < 50 &&
        <span className="outer-label">
          {countConverter(value)}
        </span>
      }
    </div >
  </div >
);

Bar.propTypes = {
  value: PropTypes.number.isRequired,
  width: PropTypes.number.isRequired,
  label: PropTypes.string.isRequired,
};
