import React from 'react';
import PropTypes from 'prop-types';
import { BreakdownResultType } from 'sandbox/types';
import { Bar } from './Bar';

export const BarList = ({ results, getWidth }) => (
  <div className="BarList">
    {
      results.map(result => (
        <Bar
          key={result.dataKey}
          label={result.dataKey}
          width={getWidth(result.value)}
          value={result.value}
        />
      ))
    }
  </div>
);

BarList.propTypes = {
  results: PropTypes.arrayOf(BreakdownResultType),
  getWidth: PropTypes.func.isRequired,
};

