import React from 'react';
import PropTypes from 'prop-types';
import { BreakdownType } from 'sandbox/types';
import { Graph } from './Graph';
import './GraphSet.scss';

export const GraphSet = ({ title, dataSet }) => (
  <div className="GraphSet">
    {dataSet.map(graphData => (
      <Graph
        results={graphData.results}
        title={`${title} - ${graphData.description}`}
      />
    ))}
  </div>
);

GraphSet.propTypes = {
  title: PropTypes.string.isRequired,
  dataSet: PropTypes.arrayOf(BreakdownType).isRequired,
};
