import React, { Component } from 'react';
import PropTypes from 'prop-types';
import { Marker } from './Marker';

export class MarkerList extends Component {

  static propTypes = {
    range: PropTypes.arrayOf(PropTypes.number).isRequired,
    css: PropTypes.string.isRequired,
  }

  getLeft = (index, { length }) => {
    const left = (565 / length) * index;
    return { left: `calc(${left - 3}px + 15%)` };
  };

  render() {
    const { range, css } = this.props;
    return (
      <ul className="MarkerList">
        {range.map((value, index) => (
          <Marker
            key={value}
            value={value}
            css={{ ...this.getLeft(index, range), ...css }}
          />))
        }
      </ul>
    );
  }
}
