import React from 'react';
import { shallow } from 'enzyme';
import { shallowToJson } from 'enzyme-to-json';

import ModalContainer from '../ModalContainer';

describe('ModalContainer', () => {

  it('Should Render Correctly', () => {
    const getState = () => ({
      modal: {
        modalData: { name: 'mock query name', id: 'mock query id', type: 'flag' },
        onClose: jest.fn(),
        visible: true,
      },
    });

    const store = {
      getState,
      dispatch: jest.fn(),
      subscribe: jest.fn(),
    };

    const output = shallow(<ModalContainer store={store} />);
    expect(shallowToJson(output)).toMatchSnapshot();
  });
});
