import { connect } from 'react-redux';
import React, { Component } from 'react';
import PropTypes from 'prop-types';
import { exportQueryToCSV } from 'sandbox/actions';
import { QueryType } from 'sandbox/types';
import './QueryExport.scss';

class QueryExport extends Component {
  static mapStateToProps = ({ query }) => ({ query });
  static propTypes = {
    query: QueryType,
    dispatch: PropTypes.func.isRequired,
    label: PropTypes.string.isRequired,
  };

  handleClick = () => {
    const { query, dispatch } = this.props;
    if (query.institutionResults.length > 0) {
      dispatch(exportQueryToCSV(query));
    }
  }

  render() {
    const { label, query } = this.props;
    const className = query.institutionResults.length === 0 ? 'QueryExport disabled' : 'QueryExport';
    return (
      <span
        className={className}
        role="button"
        onClick={this.handleClick}
      >
        {label}
      </span>
    );
  }
}
const hoc = connect(QueryExport.mapStateToProps)(QueryExport);
export { hoc as QueryExport };
