import React, { Component } from 'react';
import PropTypes from 'prop-types';

import './PagingButton.scss';

export default class PagingButton extends Component {
  static propTypes = {
    isEnabled: PropTypes.bool.isRequired,
    img: PropTypes.shape({}).isRequired,
    disabledImg: PropTypes.shape({}).isRequired,
    onClick: PropTypes.func.isRequired,
    type: PropTypes.string.isRequired,
  };

  getImage = () => {
    const { isEnabled, img, disabledImg } = this.props;
    return isEnabled ? img : disabledImg;
  };

  handleClick = () => {
    const { onClick, isEnabled } = this.props;

    if (isEnabled) {
      onClick();
    }
  };

  render() {
    const { type } = this.props;

    return (
      <div className="PagingButton" onClick={this.handleClick} role="button">
        <img alt={type} src={this.getImage()} />
      </div>
    );
  }
}
