import React, { Component } from 'react';
import PropTypes from 'prop-types';

export class QueryHistoryTableHeader extends Component {

  static propTypes = {
    id: PropTypes.string.isRequired,
    label: PropTypes.string.isRequired,
    onClick: PropTypes.func.isRequired,
    selected: PropTypes.bool.isRequired,
    isFetching: PropTypes.bool.isRequired,
  }

  state = { sort: 'asc' };

  componentWillMount() {
    const { selected } = this.props;

    if (selected) this.setState({ sort: 'desc' });
  }

  handleClick = () => {
    const {
      id,
      onClick,
      selected,
      isFetching,
    } = this.props;

    if (!isFetching) {
      const sort = (selected === false) || (this.state.sort === 'asc') ? 'desc' : 'asc';

      this.setState({ sort });
      onClick({ id, sort });
    }
  }

  render() {
    const { label, selected } = this.props;
    const { sort } = this.state;

    return (
      <th
        className="QueryHistoryTableHeader"
        onClick={this.handleClick}
      >
        {label}
        {selected && (
          sort === 'asc'
            ? <i className="fa fa-caret-up" aria-hidden="true" />
            : <i className="fa fa-caret-down" aria-hidden="true" />
        )}

      </th>
    );
  }
}
