import React from 'react';
import { shallow } from 'enzyme';
import { shallowToJson } from 'enzyme-to-json';
import { Record } from 'immutable';

import { QueryHistoryTable } from '../QueryHistoryTable';

describe('QueryHistoryTable', () => {
  const props = {
    elementId: 'Mock element id',
    resultSelected: jest.fn(),
    selectedResultId: 'Mock selected Result Id',
    onScrollReachedBottom: jest.fn(),
    onScrollReachedTop: jest.fn(),
    onFlagClicked: jest.fn(),
    onUnflagClicked: jest.fn(),
    onRenameClicked: jest.fn(),
    onHeaderClicked: jest.fn(),
    history: {
      isFetching: false,
      results: [
        {
          name: 'Mock result name',
          flagged: false,
          id: 'Mock Result Id',
          runDate: 'Mock run date',
          onSelected: jest.fn(),
          selected: true,
        },
      ],
    },
  };

  it('Should render correctly', () => {
    const output = shallow(<QueryHistoryTable {...props} />);
    expect(shallowToJson(output)).toMatchSnapshot();
  });
});
