import React from 'react';
import { shallow } from 'enzyme';
import { shallowToJson } from 'enzyme-to-json';

import { History } from 'sandbox/types';
import { QueryHistoryTableBody } from '../QueryHistoryTableBody';

describe('QueryHistoryTableBody', () => {
  const props = {
    resultSelected: jest.fn(),
    selectedResultId: 'Mock selected Result Id',
    results: History().results,
    onRenameClicked: jest.fn(),
    onFlagClicked: jest.fn(),
    onUnflagClicked: jest.fn(),
  };

  it('Should render correctly', () => {
    const output = shallow(
      <QueryHistoryTableBody
        {...props}
      />
    );

    expect(shallowToJson(output)).toMatchSnapshot();
  });
});
