import React from 'react';
import { shallow } from 'enzyme';
import { shallowToJson } from 'enzyme-to-json';

import { QueryHistoryTableHeader } from '../QueryHistoryTableHeader';

describe('QueryHistoryTableHeader', () => {
  const props = {
    id: 'Mock Header Label',
    label: 'Mock Label',
    onClick: jest.fn(),
    selected: true,
    isFetching: false,
  };

  const queryHistoryTableHeader = new QueryHistoryTableHeader(props);

  it('Should Render correctly', () => {
    const output = shallow(
      <QueryHistoryTableHeader {...props} />,
    );
    expect(shallowToJson(output)).toMatchSnapshot();
  });

  it('should handle a click event', () => {
    const output = shallow(
      <QueryHistoryTableHeader {...props} />,
    );

    output.simulate('click');
    expect(props.onClick).toHaveBeenCalled();
  });
});
