import { connect } from 'react-redux';
import React, { Component } from 'react';
import { RunQueryType } from 'sandbox/types';
import { RunQueryButton } from './RunQueryButton';

import { getProp } from 'sandbox/services';
import './RunQuery.scss';

class RunQuery extends Component {
  static propTypes = { runQuery: RunQueryType.isRequired };

  doRunQuery = () => {
    const { canRunQuery } = this.props.runQuery;
    if (canRunQuery === true) {
      getProp('i2b2.CRC.ctrlr.QT.doQueryRun')
        .apply(getProp('i2b2.CRC.ctrlr.QT'));
    }
  }
  render() {
    const { canRunQuery } = this.props.runQuery;
    const className = canRunQuery === true ? 'RunQuery' : 'busy';
    return (
      <RunQueryButton
        handleClick={this.doRunQuery}
        className={className}
      />
    );
  }
}

const mapStateToProps = ({ runQuery }) => ({ runQuery });
const hoc = connect(mapStateToProps)(RunQuery);
export { hoc as RunQuery };
