import React from 'react';
import PropTypes from 'prop-types';

export const RunQueryButton = ({ className, handleClick, children }) => (
  <button
    className={className}
    onClick={handleClick}
  >
    <div>{children}</div>
  </button>
);

RunQueryButton.propTypes = {
  className: PropTypes.string.isRequired,
  handleClick: PropTypes.func.isRequired,
  children: PropTypes.string,
};

RunQueryButton.defaultProps = { children: 'Run Query' };
