import React, { PureComponent } from 'react';
import PropTypes from 'prop-types';

class StatusAndGraphTab extends PureComponent {
  static propTypes = {
    children: PropTypes.string.isRequired,
    isSelected: PropTypes.bool.isRequired,
    clickHandler: PropTypes.func.isRequired,
  }

  clickHandler = () => {
    this.props.clickHandler();
  }

  render() {
    const { isSelected } = this.props;
    const classNames = `tabBox query-viewer ${isSelected ? 'active' : ''}`;
    return (
      <div
        className={classNames}
        role="button"
        onClick={this.clickHandler}
      >
        <div>{this.props.children}</div>
      </div>
    );
  }
}

export default StatusAndGraphTab;
