import React, { PureComponent } from 'react';
import { connect } from 'react-redux';
import PropTypes from 'prop-types';
import { TabType } from 'sandbox/types';
import Tab from './StatusAndGraphTab';
import { selectTab } from 'sandbox/actions';
import {
  QUERY_STATUS,
  BREAKDOWNS,
} from 'sandbox/defaultState';


class StatusAndGraphTabContainer extends PureComponent {
  static mapStateToProps = ({ tabs }) => ({ tabs });
  static propTypes = {
    tabs: TabType,
    dispatch: PropTypes.func.isRequired,
  }

  selectBreakdownsView = () => this.props.dispatch(selectTab(BREAKDOWNS));
  selectQueryStatusView = () => this.props.dispatch(selectTab(QUERY_STATUS));

  render() {
    const { tabs } = this.props;

    return (
      <div>
        <Tab
          isSelected={tabs.selectedTab === QUERY_STATUS}
          clickHandler={this.selectQueryStatusView}
        >
          Query Status
        </Tab>
        <Tab
          isSelected={tabs.selectedTab === BREAKDOWNS}
          clickHandler={this.selectBreakdownsView}
        >
          Breakdowns
        </Tab>
      </div>
    );
  }
}
export default connect(StatusAndGraphTabContainer.mapStateToProps)(StatusAndGraphTabContainer);

