import React from 'react';
import { shallow } from 'enzyme';
import { shallowToJson } from 'enzyme-to-json';
import StatusAndGraphTab from './../StatusAndGraphTab';

describe('StatusAndGraphTab ', () => {
  const clickHandler = jest.fn();
  it('should render correctly', () => {
    const isSelected = true;
    const output = shallow(
      <StatusAndGraphTab
        isSelected={isSelected}
        clickHandler={clickHandler}
      >
        Tab Label
      </StatusAndGraphTab >,
    );
    expect(shallowToJson(output)).toMatchSnapshot();
  });
  it('should handle a click event', () => {
    const isSelected = false;
    const output = shallow(
      <StatusAndGraphTab
        isSelected={isSelected}
        clickHandler={clickHandler}
      >
        Tab Label
      </StatusAndGraphTab >,
    );
    output.simulate('click');
    expect(clickHandler).toHaveBeenCalled();
  })
});