// https://medium.com/wehkamp-techblog/unit-testing-your-react-application-with-jest-and-enzyme-81c5545cee45
import React from 'react';
import { shallow } from 'enzyme';
import { shallowToJson } from 'enzyme-to-json';
import StatusAndGraphTabContainer from './../StatusAndGraphTabContainer';

describe('StatusAndGraphTabContainer', () => {
  const getState = () => ({ tabs: { selectedTab: 'SELECTED_TAB' } });
  const store = {
    getState,
    dispatch: jest.fn(),
    subscribe: jest.fn(),
  };
  it('should render correctly', () => {
    const output = shallow(
      <StatusAndGraphTabContainer
        store={store}
      />
    );
    expect(shallowToJson(output)).toMatchSnapshot();
  });
});