import React from 'react';
import { TabType, QueryType } from 'sandbox/types';
import { SelectedQuery } from 'sandbox/components/SelectedQuery';
import { Breakdowns } from 'sandbox/components/Breakdowns';
import './StatusAndGraphView.scss';

const StatusAndGraphsView = (props) => {
  const { query, tabs } = props;
  return (
    <div>
      {tabs.selectedTab === 'QUERY_STATUS'
        ? <SelectedQuery
          query={query}
        />
        : <Breakdowns
          breakdowns={query.breakdowns}
          breakdownMsg={query.breakdownMsg}
        >
          {query.name}
        </Breakdowns>
      }
    </div>
  );
};

StatusAndGraphsView.propTypes = {
  tabs: TabType,
  query: QueryType,
};
export default StatusAndGraphsView;
