import React from 'react';
import { TabType, QueryType } from 'sandbox/types';
import { connect } from 'react-redux';
import { FetchError } from 'sandbox/components/FetchError';
import StatusAndGraphsView from './StatusAndGraphView';

const ViewContainer = (props) => {
  const {
    tabs,
    query,
  } = props;
  return (
    <div>
      {query.error
        ? <FetchError
          url={query.url}
          errorMsg={query.errorMsg}
        />
        : <StatusAndGraphsView
          query={query}
          tabs={tabs}
        />
      }
    </div>
  );
};
ViewContainer.mapStateToProps = ({ tabs, query }) => ({ tabs, query });
ViewContainer.propTypes = { tabs: TabType, query: QueryType };
export default connect(ViewContainer.mapStateToProps)(ViewContainer);
