import React, { Component } from 'react';
import PropTypes from 'prop-types';
import { InstitutionResultType } from 'sandbox/types';

export class ClickableStatus extends Component {

  static propTypes = {
    className: PropTypes.string.isRequired,
    statusText: PropTypes.string.isRequired,
    data: InstitutionResultType.isRequired,
    handleStatusClicked: PropTypes.func.isRequired,
  }

  handleClick = () => {
    const { data, handleStatusClicked } = this.props;
    handleStatusClicked(data);
  }

  render() {
    const { className, statusText } = this.props;
    return (
      <div
        className={className}
      >
        {statusText}&nbsp;
        <span onClick={this.handleClick} role="button">
          click for details
        </span>
      </div>
    );
  }
}
