import React from 'react';
import PropTypes from 'prop-types';
import { InstitutionResultType } from 'sandbox/types';
import { InstitutionResultStatus } from './InstitutionResultStatus';

export const InstitutionResultStatusList = (props) => {
  const { institutionResults, errorDetailPopUp } = props;
  return (
    <div className="QueryCountList">
      {institutionResults.map(result => (
        <InstitutionResultStatus
          key={result.institutionName}
          result={result}
          handleStatusClicked={errorDetailPopUp}
        />))
      }
    </div>
  );
};

InstitutionResultStatusList.propTypes = {
  institutionResults: PropTypes.arrayOf(InstitutionResultType).isRequired,
  errorDetailPopUp: PropTypes.func.isRequired,
};
