import React from 'react';
import PropTypes from 'prop-types';

import { QueryType } from 'sandbox/types';
import { Status } from './Status';
import { ClickableStatus } from './ClickableStatus';

export const QueryStatus = ({ query, handleErrorStatusClicked }) => {
  const { status = 'Submitted' } = query;

  return (
    !query.isQueryError
      ? <Status
        statusText={status}
        className="QueryNonError"
      />
      : <ClickableStatus
        statusText={status}
        className="QueryError"
        data={query}
        handleStatusClicked={handleErrorStatusClicked}
      />
  );
};

QueryStatus.propTypes = {
  query: QueryType.isRequired,
  handleErrorStatusClicked: PropTypes.func.isRequired,
};
