import React from 'react';
import { shallow } from 'enzyme';
import { shallowToJson } from 'enzyme-to-json';

import { ClickableStatus } from './../ClickableStatus';

describe('ClickableStatus ', () => {
  const clickHandler = jest.fn();
  const mockData = {

  };

  it('should render correctly', () => {
    const output = shallow(
      <ClickableStatus
        className="PatientCount"
        statusText="101 patients"
        data={mockData}
        handleStatusClicked={clickHandler}
      />,
    );
    expect(shallowToJson(output)).toMatchSnapshot();
  });
  it('should handle when status is clicked', () => {
    const isSelected = false;
    const output = shallow(
      <ClickableStatus
        className="PatientCount"
        statusText="101 patients"
        data={mockData}
        handleStatusClicked={clickHandler}
      />,
    );

    output.find('span').at(0).simulate('click');
    expect(clickHandler).toHaveBeenCalled();
  });
});