import React from 'react';
import { shallow } from 'enzyme';
import { shallowToJson } from 'enzyme-to-json';

import { } from 'sandbox/types';
import { InstitutionResultStatus } from './../InstitutionResultStatus';

describe('InstitutionResultStatus ', () => {
  const props = {
    result: {
      institutionName: 'mock institution name',
      count: 100,
      internalStatus: 'mock internal status',
      status: 'mock status',
      statusMessage: 'mock status message',
      error: false,
      problemDigest: { },
    },
    handleStatusClicked: jest.fn(),
  };

  it('should render correctly', () => {
    const output = shallow(
      <InstitutionResultStatus
        {...props}
      />,
    );
    expect(shallowToJson(output)).toMatchSnapshot();
  });
});