import React from 'react';
import { shallow } from 'enzyme';
import { shallowToJson } from 'enzyme-to-json';

import { InstitutionResultStatusList } from './../InstitutionResultStatusList';

describe('InstitutionResultStatusList ', () => {
  const props = {
    institutionResults: [{
      institutionName: 'mock institution name',
      count: 100,
      status: 'mock status',
      statusMessage: 'mock status message',
      error: false,
      problemDigest: { },
    }],
    handleStatusClicked: jest.fn(),
  };

  it('should render correctly', () => {
    const output = shallow(
      <InstitutionResultStatusList
        {...props}
      />,
    );
    expect(shallowToJson(output)).toMatchSnapshot();
  });
});