import React from 'react';
import { shallow } from 'enzyme';
import { shallowToJson } from 'enzyme-to-json';

import { } from 'sandbox/types';
import { QueryStatus } from './../QueryStatus';

describe('QueryStatus ', () => {
  const props = {
    query: {
      name: 'Mock Query',
      networkId: '12345',
      updated: 1001,
      statusMsg: 'Mock status message',
      status: 'Complete',
      error: false,
      errorMsg: null,
      url: 'mock url',
      isRunning: false,
      institutionResults: [{
        institutionName: 'Mock Institution',
        count: 100,
        status: 'Mock status',
        statusMessage: 'Mock node status',
        error: false,
        problemDigest: null,
      }],
    },
    handleErrorStatusClicked: jest.fn(),
  };

  it('should render correctly', () => {
    const output = shallow(
      <QueryStatus
        {...props}
      />,
    );
    expect(shallowToJson(output)).toMatchSnapshot();
  });
});