import React from 'react';
import { shallow } from 'enzyme';
import { shallowToJson } from 'enzyme-to-json';

import { withPopUp } from '../withPopUp';

describe('withPopUp', () => {
  const MockComponent = () => (<span id="MockComponent">Mock Component</span>);
  const MockComponentWithPopUp = withPopUp(MockComponent);

  it('Should render correctly', () => {
    const hidden = false;
    const output = shallow(<MockComponentWithPopUp hidden={hidden} />);
    expect(shallowToJson(output)).toMatchSnapshot()
  });

  it('The component should have the .hidden class applied if hidden is true', () => { 
    const hidden = true;
    const output = shallow(<MockComponentWithPopUp hidden={hidden} />);
    const expected = 1;
    const actual = output.find('.hidden').length;
    expect(actual).toBe(expected);
  });

  it('The component should not have the .hidden class applied if hidden is true', () => { 
    const hidden = false;
    const output = shallow(<MockComponentWithPopUp hidden={hidden} />);
    const expected = 0;
    const actual = output.find('.hidden').length;
    expect(actual).toBe(expected);
  });
});