import React from 'react';
import PropTypes from 'prop-types';

import './withPopUp.scss';

export const withPopUp = (WrappedComponent) => {
  const WithPopUp = (props) => {
    const { hidden } = props;
    const className = hidden === false ? 'withPopUp' : 'withPopUp hidden';
    return (
      <div className={className}>
        {hidden === false && <WrappedComponent {...props} />}
      </div>
    );
  };
  WithPopUp.propTypes = { hidden: PropTypes.bool.isRequired };
  return WithPopUp;
};
