import { truncate } from '../truncate';

describe('Truncate Converter', () => {

  const mockString = 'mock-string';

  it('Should truncate a string with a length greater than N number of characters', () => {
    const maxStringLength = 4;
    const expected = 'mock...';
    const actual = truncate(mockString, maxStringLength);
    expect(actual).toBe(expected);
  });

  it('Should not truncate a string with a length less than N number of characters', () => {
    const maxStringLength = 100;
    const expected = mockString;
    const actual = truncate(mockString, maxStringLength);
    expect(actual).toBe(expected);
  });

  it('Should default to a max length of 20 when a length is not provied', () => {
    const lengthOfTwentyOne = '123456789123456789123';
    const expected = '12345678912345678912...';
    const actual = truncate(lengthOfTwentyOne);
    expect(actual).toBe(expected);
  });
});