import moment from 'moment';

export const timestamp = (earlierUTC, laterUTC = Date.now()) => {
  const diffInSeconds = moment(Number(laterUTC)).diff(Number(earlierUTC), 'seconds');
  const diffInDays = moment(Number(laterUTC)).diff(Number(earlierUTC), 'days', true);

  if (diffInSeconds < 60) {
    return `${diffInSeconds} seconds ago`;
  } else if (diffInDays < 1) {
    return moment(earlierUTC).fromNow();
  }
  return moment(Number(earlierUTC)).format('MM/DD/YYYY');
};
