import { createStore, applyMiddleware, combineReducers } from 'redux';
import createSagaMiddleware from 'redux-saga';
import { initSagas } from './initSagas';
import * as appReducer from './reducers';
import defaultState from './defaultState';

let mutableStore;
export const getStore = () => {
  if (!mutableStore) {
    const sagaMiddleware = createSagaMiddleware();
    mutableStore = createStore(combineReducers(appReducer), defaultState, applyMiddleware(sagaMiddleware));
    initSagas(sagaMiddleware);
  }
  return mutableStore;
};
