import { defaultState } from 'sandbox/defaultState';
import {
  FLAG_QUERY,
  UNFLAG_QUERY,
  RENAME_QUERY,
  HIDE_MODAL,
} from 'sandbox/actions';

const { modal } = defaultState;
export const modalReducer = (state = modal, action) => {
  switch (action.type) {

    case FLAG_QUERY: {
      const { modalData } = action.payload;
      return {
        modalData: { ...modalData, type: 'flag' },
        showModal: true,
      };
    }
    case UNFLAG_QUERY: {
      const { modalData } = action.payload;
      return {
        modalData: { ...modalData, type: 'unflag' },
        showModal: true,
      };
    }
    case RENAME_QUERY: {
      const { modalData } = action.payload;
      return {
        modalData: { ...modalData, type: 'rename' },
        showModal: true,
      };
    }

    case HIDE_MODAL: return modal;

    default: return state;
  }
};
