import { takeLatest, call, put } from 'redux-saga/effects';
import { mapQueryToCSV, publishCSV } from 'sandbox/services';
import { doExportToCSV, queryExportSaga } from 'sandbox/sagas/queryExportSaga';
  
describe('Do Export to CSV', () => {
  const payload = { };
  const generator = doExportToCSV({
    type: 'EXPORT_QUERY_TO_CSV',
    payload,
  });

  it('Should call the mapQueryToCSV method', () => {
    const actual = generator.next().value;
    const expected = call(mapQueryToCSV, payload);
    expect(actual).toEqual(expected);
  });

  it('Should call the mapQueryToCSV method', () => {
    const actual = generator.next().value;
    const expected = call(publishCSV, undefined);
    expect(actual).toEqual(expected);
  });
});
