import { call, takeLatest } from 'redux-saga/effects';
import { EXPORT_QUERY_TO_CSV } from 'sandbox/actions';
import { mapQueryToCSV, publishCSV } from 'sandbox/services';

export function* doExportToCSV(action) {
  const { payload: query } = action;
  const csv = yield call(mapQueryToCSV, query);
  yield call(publishCSV, csv);
}

export function* queryExportSaga() {
  yield takeLatest(EXPORT_QUERY_TO_CSV, doExportToCSV);
}
