import { getBaseUrl } from '../getBaseUrl';
import { Iterable } from 'immutable';
describe('Get Base URL', () => {
  it('Should yield a default dev url if global i2b2 is not defined', () => {
    const expected = '/shrine-api/';
    const actual = getBaseUrl();
    expect(actual).toBe(expected);
  });

  it('Should yield a url matching the configuration in i2b2', () => {
    const context = { i2b2: { hive: { cfg: { shrineUrl: 'mock-url-here/' } } } };
    const expected = 'mock-url-here/';
    const actual = getBaseUrl(context);
    expect(actual).toBe(expected);
  });

  it('Should add a slash to a base url if it is missing', () => {
    const context = { i2b2: { hive: { cfg: { shrineUrl: 'mock-url-here' } } } };
    const expected = 'mock-url-here/';
    const actual = getBaseUrl(context);
    expect(actual).toEqual(expected);
  })
});