import { makeAscendingSortComparer } from '../makeAscendingSortComparer';

describe('Make Ascending Sort Comparer', () => {
  const objA = { prop: 'propA' };
  const objB = { prop: 'propB' };
  const selector = ({ prop }) => prop.toUpperCase();
  const comparer = makeAscendingSortComparer(selector);
  it('Should create a method that returns 1 if an object property comes after another', () => {
    const expected = 1;
    const actual = comparer(objB, objA);
    expect(actual).toBe(expected);
  });
  it('Should create a method that returns -1 if an object property comes before another', () => {
    const expected = -1;
    const actual = comparer(objA, objB);
    expect(actual).toBe(expected);
  });
  it('Should create a method that returns 1 if two object properties are equal', () => {
    const expected = 0;
    const actual = comparer(objA, objA);
    expect(actual).toBe(expected);
  });
});