import { mapBreakdownsToArray } from '../mapBreakdownsToArray';

describe('mapBreakdownsToArray', () => {

  it('Should take an breakdown object with properties that are node names where each property is mapped to an array of results and map it to an array of objects', () => {
    const breakdowns = {
      node1: ['result1', 'result2', 'result3'],
      node2: ['result1', 'result2', 'result3'],
    };
    const expected = [{
      institution: 'node1',
      results: ['result1', 'result2', 'result3'],
    }, {
      institution: 'node2',
      results: ['result1', 'result2', 'result3'],
    }];
    const actual = mapBreakdownsToArray(breakdowns);
    expect(actual).toEqual(expected);
  });
});
