import { mapInstitutionResultsToBreakdowns } from '../mapInstitutionResultsToBreakdowns';



describe('mapInstitutionResultsToBreakdowns', () => {
  const institutionResults = [{
    institutionName: 'mock-institution',
    status: 'Completed',
    internalStatus: 'result from crc',
    breakdowns: [{
      resultType: { i2b2Options: { description: 'mock breakdown description' } },
      results: [{
        dataKey: 'mock data key',
        value: -1,
      }],
    }],
  }, {
    institutionName: 'submitted-institution',
    status: 'Submitted',
    internalStatus: 'mock internal status',
    breakdowns: [],
  }, {
    institutionName: 'no-breakdown-institution',
    status: 'Completed',
    internalStatus: 'result crom crc',
    breakdowns: [],
  }];

  it('Should only map institutionResults that have FINISHED status and also have breakdowns to a breakdown object mapped by instution', () => {
    const expected = {
      'mock-institution': [{
        description: 'mock breakdown description',
        results: [{ dataKey: 'mock data key', value: -1 }],
      }],
    };
    const actual = mapInstitutionResultsToBreakdowns(institutionResults);
    expect(actual).toEqual(expected);
  });
});