import { mapQueryToCSV } from '../mapQueryToCSV';


describe('mapQueryToCSV', () => {
  const query = {
    queryName: 'mock-query',
    changeDate: 1501001607335,
    breakdowns: {
      'mock-institution': [{
        description: 'mock breakdown description',
        results: [
          { value: -1, dataKey: 'Other' },
          { value: -1, dataKey: 'Asian Pacific Islander' },
          { value: -1, dataKey: 'Middle Eastern' },
          { value: -1, dataKey: 'Not recorded' },
          { value: -1, dataKey: 'Eskimo' },
          { value: -1, dataKey: 'American Indian' },
          { value: 80, dataKey: 'White' },
          { value: -1, dataKey: 'Native American' },
          { value: 370, dataKey: 'Black' },
          { value: -1, dataKey: 'Multiracial' },
          { value: 170, dataKey: 'Hispanic' },
          { value: 95, dataKey: 'Indian' },
          { value: -1, dataKey: 'Aleutian' },
          { value: 105, dataKey: 'Asian' },
          { value: -1, dataKey: 'Oriental' },
          { value: -1, dataKey: 'Navajo' },
        ],
      },
      ],
    },
    institutionResults: [{
      count: 1795,
      statusMessage: 'FINISHED',
      changeDate: 1501001608966,
      instanceId: 174,
      resultId: 320,
      status: 'FINISHED',
      institutionName: 'mock-institution',
    }],
  };

  it('Should map query Redux state object to a CSV', () => {
    const expected = `
      SHRINE QUERY RESULTS (OBFUSCATED PATIENT COUNTS),, mock-institution
      All Patients,,1795,
      mock breakdown description Other,,0,
      mock breakdown description Asian Pacific Islander,,0,
      mock breakdown description Middle Eastern,,0,
      mock breakdown description Not recorded,,0,
      mock breakdown description Eskimo,,0,
      mock breakdown description American Indian,,0,
      mock breakdown description White,,80,
      mock breakdown description Native American,,0,
      mock breakdown description Black,,370,
      mock breakdown description Multiracial,,0,
      mock breakdown description Hispanic,,170,
      mock breakdown description Indian,,95,
      mock breakdown description Aleutian,,0,
      mock breakdown description Asian,,105,
      mock breakdown description Oriental,,0,
      mock breakdown description Navajo,,0`;
    const actual = mapQueryToCSV(query);
    expect(actual.replace(/\s/g, '')).toEqual(expected.replace(/\s/g, ''));
  })
});
