import { mapResultsToInstitutionResults } from '../mapResultsToInstitutionResults';

describe('mapResultsToInstitutionResults', () => {
  it('Should map an API result to an InstitutionResult', () => {
    const apiResults = [{
      adapterNode: 'mock-institution',
      count: 0,
      status: 'MOCK_STATUS',
      internalStatus: 'mock internal status',
      statusMessage: 'mock status message',
      problemDigest: { details: '' },
    }];
    const expected = [{
      breakdowns: [],
      count: 0,
      institutionName: 'mock-institution',
      problemDigest: { details: '' },
      status: 'MOCK_STATUS',
      internalStatus: 'mock internal status',
      statusMessage: 'mock status message',
    }];
    const actual = mapResultsToInstitutionResults(apiResults);
    expect(actual).toEqual(expected);
  });
});