import { makeAscendingSortComparer } from './makeAscendingSortComparer';

export const mapResultsToInstitutionResults = (results) => {
  const adapterSort = makeAscendingSortComparer(({ adapterNode }) => adapterNode.toUpperCase());
  return results.sort(adapterSort).map((result) => {
    const {
      adapterNode,
      count,
      internalStatus,
      status,
      statusMessage,
      problemDigest = {},
      breakdowns = [],
    } = result;
    return {
      institutionName: adapterNode,
      count,
      status,
      internalStatus,
      statusMessage,
      problemDigest,
      breakdowns,
    };
  });
};
