export const EXPORT_FILENAME = 'export.csv';
export const publishCSV = (csv, context = window.parent) => {
  if (context === undefined) return;
  const filename = EXPORT_FILENAME;
  const blob = new Blob([csv]);
  const isIE = context.navigator !== undefined && context.navigator.msSaveOrOpenBlob !== undefined;
  if (isIE) context.navigator.msSaveBlob(blob, filename);
  else {
    const a = context.parent.document.createElement('a');
    a.href = context.URL.createObjectURL(blob, { type: 'text/plain' });
    a.download = filename;
    context.document.body.appendChild(a);
    a.click();
    context.document.body.removeChild(a);
  }
};
