import PropTypes from 'prop-types';
import { Record, List } from 'immutable';

export const SORT_BY_DATE_CREATED_ASCENDING = 'dateCreated.asc';
export const SORT_BY_DATE_CREATED_DESCENDING = 'dateCreated.desc';
export const SORT_BY_QUERY_NAME_ASCENDING = 'queryName.asc';
export const SORT_BY_QUERY_NAME_DESCENDING = 'queryName.desc';

export const History = Record({
  sortBy: SORT_BY_DATE_CREATED_DESCENDING,
  results: List(),
  limit: 34,
  rowCount: 0,
  rowOffset: 0,
  error: false,
  errorMsg: null,
  url: null,
  isFetching: false,
  selectedResultId: null,
});

export const HistoryType = PropTypes.shape(History());
