package net.shrine.messagequeueservice

import cats.effect.IO

/**
  * A Message Trait that is implemented by SimpleMessage and MessageQueueClientMessage
  * Created by yifan on 9/8/17.
  */

trait Message {

  /**
    * Call after the receiver has completed work on this message to prevent it being redelivered
    */
  def completeIO(): IO[Unit]

  def contents: String

  //todo aws may not have a deliveryAttemptId Long. Move to protocol if needed
  def deliveryAttemptId:DeliveryAttemptId

  //todo aws may not have a timeToComplete Long. Move to protocol if needed
  def millisecondsToComplete:Long

  def remainingAttempts:Int
}
