import React, { Component } from 'react';
import './App.css';
import Header from './Header.js';
import StatusMain from './StatusMain.js';
import Note from './Note.js';
import Legend from './Legend.js';


class App extends Component {

    constructor(props) {
        super(props);
        this.state = {
            data: null,
        };
    }

    componentDidMount() {
        fetch(`data/network_status.json`)
            .then(result=>result.json())
            .then(data=>this.setState({data}))
    };

    render() {
        document.title = (this.state.data !== null) && this.state.data.networkName + " Network Health";

        return (this.state.data !== null) && (
            <div className="App child">
                <Note alertMessage={this.state.data.alertMessage} />
                <Header timestamp = {this.state.data.timestamp} networkName= {this.state.data.networkName}/>
                <div className="App-intro">
                    <StatusMain nodes={this.state.data.nodes}/>
                    <Legend note={this.state.data.note}/>
                </div>
            </div>
        );
    }
}

export default App;
