import React, { Component } from 'react';
import moment from 'moment';
import timezone from 'moment-timezone';
import jstz from 'jstz';
import './Header.css';


export const dateTimeWithZone =( value, timeZone) => moment(value, timeZone).tz(timeZone).format('MMM DD, YYYY [at] h:mm:ss a z');

class Header extends Component {

    render() {

        const { networkName } = this.props;
        const defaultTz = 'America/New_York';
        const changeDate = new Date(this.props.timestamp);

        return (
            <header className="App-header">
                <h1 className="App-title">{networkName} Site Connectivity Status</h1>
                <div className="App-changeDate">Status last updated: {dateTimeWithZone(changeDate, defaultTz)} </div>
            </header>
        );
    }
}

export default Header;
