import React, { Component } from 'react';
import './StatusMain.css';
import NodeListing from './NodeListing.js';


class StatusMain extends Component {

    render() {
        const nodes = this.props.nodes;
        const maxRowLength = Math.ceil(nodes.length / 2);
        const firstHalf = nodes.slice(0, maxRowLength);
        const secondHalf = nodes.slice(maxRowLength, nodes.length);

        let leftNodeListing;
        let rightNodeListing;

        if(firstHalf.length > 0){
            leftNodeListing = <div className="flex"> <NodeListing nodes={firstHalf}/> </div>;
        }

        if(secondHalf.length > 0){
            rightNodeListing = <div className="flex"> <NodeListing nodes={secondHalf}/> </div>;
        }
        return nodes !== null && (
            <div className="flex">
                {leftNodeListing}
                {rightNodeListing}
            </div>
        );
    }
}

export default StatusMain;
